/*****************************************************************************
 *
 * Atmel Corporation
 *
 * ̧		: AVRDevice.hpp
 * ߲	: Dev-C++ 4.9.8.0 - http://bloodshed.net/dev/
 * 		: $Revision: 1163 $
 * t		: $Date: 2006N82 15:38:16 +0200 $
 * XV	: $Author: ohlia $
 *
 * xҰ	: avr@atmel.com
 *
 * ړI	: Win32
 *
 * pLq	: AVR911 - AVRJ݊
 *
 * 		: ޲ؗʂȂǂ̏܂޸׽BAVR Studio 4ŋ
 *			  ޲Lq̧ق炻Ұǂނ߂̊֐񋟂܂B
 *
 ****************************************************************************/
#ifndef AVRDEVICE_HPP
#define AVRDEVICE_HPP

using namespace std;


#include <string>
#include <vector>
#include "Utility.hpp"
#include "XMLParser.hpp"
#include "ErrorMsg.hpp"

class AVRDevice
{
	protected:
		string deviceName;						// ޲̖OAႦ΁AATmega128

		long flashSize;							// ޲Ăłׯ ؂̑傫
		long eepromSize;						// ޲ĂłEEPROM̑傫
		bool hasFuseBits;						// ޲ł˭ ޯĂ?
		bool hasExtendedFuseBits;				// ޲g˭ނ?
		long signature0;
		long signature1;
		long signature2;						// XML޲Lq̧قǂ3̎[޲
		long pagesize;							// ׯ ߰ޗe

	public:
		/* ݽ׸ */
		AVRDevice( const string & _deviceName );

		/* ޽׸ */
		~AVRDevice();

		/* ҿ */
		void readParametersFromAVRStudio( vector<string> & searchpath );

		long getFlashSize() { return flashSize; }
		long getEEPROMSize() { return eepromSize; }
		long getPageSize() { return pagesize; }
		bool getFuseStatus() { return hasFuseBits; }
		bool getXFuseStatus() { return hasExtendedFuseBits; }

		void getSignature( long * sig0, long * sig1, long * sig2 );
};

#endif
