/*****************************************************************************
 *
 * Atmel Corporation
 *
 * ̧		: SerialPort.hpp
 * ߲	: Dev-C++ 4.9.8.0 - http://bloodshed.net/dev/
 * 		: $Revision: 1163 $
 * t		: $Date: 2006N82 15:38:16 +0200 $
 * XV	: $Author: ohlia $
 *
 * xҰ	: avr@atmel.com
 *
 * ړI	: Win32
 *
 * pLq	: AVR911 - AVRJ݊
 *
 * 		: PCCOM߰ĂʂļرْʐM񋟂׽B̸׽CommChannel
 *			  ۸׽h܂B
 *
 ****************************************************************************/
#ifndef SERIALPORT_HPP
#define SERIALPORT_HPP

using namespace std;

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <time.h>
#include <iostream>
#include "CommChannel.hpp"
#include "ErrorMsg.hpp"


class SerialPort : public CommChannel
{
	protected:
		long portNumber;						// COMx߰Ĕԍ
		long timeout;							// ްMŗv鐧
		HANDLE serialHandle;					// COM߰Ăɑ΂Win32u
		COMMTIMEOUTS oldComTimeouts;			// ر ߰ċҰۑ
		bool channelOpen;						// قJĂ邩?

	public:
		// ҰƂ߰ĔԍAްڰāAԂݽ׸
		SerialPort( long portnumber, long timeout );

		// ޽׸
		~SerialPort();

		// ʐMقJ
		virtual void openChannel();

		// ʐMق
		virtual void closeChannel();

		// P޲đM
		virtual void sendByte( long data );

		// P޲ĎM
		virtual long getByte();

		// MɏՕj
		virtual void flushTX();

		// MɏՕj
		virtual void flushRX();

		// ޲đM
		virtual void sendMultiple( unsigned char * data, long bufsize );
};

#endif
